<?php
    /*
    * Module APlayerFP pour Joomla! 3.x
    * Version J3.1P
    * Creation date: Octobre 2015
    * Author: Fabrice4821 - www.gmapfp.org
    * Author email: webmaster@gmapfp.org
	* License GNU/GPL
    */

defined('_JEXEC') or die;
jimport( 'joomla.filesystem.folder' ); 
jimport( 'joomla.filesystem.file' ); 

// Reference global application object
$app = JFactory::getApplication();
$input = $app->input;

// Load language file for module
$lang     = JFactory::getLanguage();
$lang->load('mod_aplayerfp', JPATH_BASE, null, false, true);

$task = $input->get('task', '');
$module_id = $input->getInt('module_id', '');
$audio_dir = JPATH_ROOT.'/modules/mod_aplayerfp/audio/'.$module_id;

if ($task == 'add') {

	$allowed_ext = array('ogg','mp3','wav');
	$data_info = '';

	if(!file_exists($audio_dir)){
		JFolder::create($audio_dir);
		$data = '<html><body bgcolor="#FFFFFF"></body></html>';
		JFile::write($audio_dir.'/index.html', $data);
	}

	if(strtolower($_SERVER['REQUEST_METHOD']) != 'post'){            
		exit_upload(JText::_('MOD_APLAYERFP_CTRL_FILES_WRONG_HTTP_RESPONSE'));
	}

	if(array_key_exists('fpfile',$_FILES) && $_FILES['fpfile']['error'] == 0 ){

			$fpfile = $_FILES['fpfile'];
			if(!in_array(strtolower(JFile::getExt($fpfile['name'])),$allowed_ext)){
				exit_upload(JText::_('COM_APLAYERFP_CTRL_FILES_WRONG_FILE_EXTENSION'));
			}
		   
			if(!JFile::upload($fpfile['tmp_name'], $audio_dir.'/'.$fpfile['name'])){
				exit_upload(JText::_('COM_APLAYERFP_CTRL_FILES_CANT_MOVE_FILE'));
			}

		function calcul_time($the_time) {
			$minutes = '00' . floor($the_time / 60);
			$minutes = substr($minutes,-2);
			$secondes = '00' . ($the_time % 60);
			$secondes = substr($secondes,-2);
			return $minutes.JText::_('MOD_APLAYERFP_MINUTES') . ' ' . $secondes.JText::_('MOD_APLAYERFP_SECONDES');
		}

		require_once(JPATH_ROOT.'/modules/mod_aplayerfp/fields/getid3/getid3.php');
			$getID3 = new getID3; 
			$getID3->option_md5_data        = true; 
			$getID3->option_md5_data_source = true; 
			$getID3->encoding               = 'UTF-8'; 

			$info = $getID3->analyze($audio_dir.'/'.$fpfile['name']);
				$result = array(); 
				$result['album']        = (isset($info['id3v2']['comments']['album'])	? $info['id3v2']['comments']['album'][0]	: ''); 
				$result['title']       	= (isset($info['id3v2']['comments']['title'])	? $info['id3v2']['comments']['title'][0]	: ''); 
				$result['format_name']  = (isset($info['audio']['dataformat'])			? $info['audio']['dataformat'] 				: ''); 
				$result['channels']     = (isset($info['audio']['channelmode'])			? $info['audio']['channelmode']				: ''); 
				$result['bitrate']     	= (isset($info['audio']['bitrate'])				? $info['audio']['bitrate']         		: ''); 
				$result['playing_time'] = (isset($info['playtime_seconds'])				? calcul_time(round($info['playtime_seconds']))  	: ''); 
				$result['comment']      = (isset($info['id3v2']['comments']['comment'])	? $info['id3v2']['comments']['comment'][0]	: ''); 
				
		$data_info = '<table class="table-info">'."\n";
		$data_info .= '<body>'."\n";
		$data_info .= '<tr>'."\n";
		$data_info .= '<td class="titre">'.JText::_('MOD_APLAYERFP_FILE_NAME').' : </td>'."\n";
		$data_info .= '<td class="info">'.$result['title'].'</td>'."\n";
		$data_info .= '</tr>'."\n";
		$data_info .= '<tr>'."\n";
		$data_info .= '<td class="titre">'.JText::_('MOD_APLAYERFP_ALBUM').' : </td>'."\n";
		$data_info .= '<td class="info">'.$result['album'].'</td>'."\n";
		$data_info .= '</tr>'."\n";
		$data_info .= '<tr>'."\n";
		$data_info .= '<td class="titre">'.JText::_('MOD_APLAYERFP_CHANNELS').' : </td>'."\n";
		$data_info .= '<td class="info">'.$result['channels'].'</td>'."\n";
		$data_info .= '</tr>'."\n";
		$data_info .= '<tr>'."\n";
		$data_info .= '<td class="titre">'.JText::_('MOD_APLAYERFP_FORMAT_NAME').' : </td>'."\n";
		$data_info .= '<td class="info">'.$result['format_name'].'</td>'."\n";
		$data_info .= '</tr>'."\n";
		$data_info .= '<tr>'."\n";
		$data_info .= '<td class="titre">'.JText::_('MOD_APLAYERFP_SAMPLE_RATE').' : </td>'."\n";
		$data_info .= '<td class="info">'.$result['bitrate'].'</td>'."\n";
		$data_info .= '</tr>'."\n";
		$data_info .= '<tr>'."\n";
		$data_info .= '<td class="titre">'.JText::_('MOD_APLAYERFP_PLAYING_TIME').' : </td>'."\n";
		$data_info .= '<td class="info">'.$result['playing_time'].'</td>'."\n";
		$data_info .= '</tr>'."\n";
		$data_info .= '<tr>'."\n";
		$data_info .= '<td class="titre">'.JText::_('MOD_APLAYERFP_COMMENT').' : </td>'."\n";
		$data_info .= '<td class="info">'.$result['comment'].'</td>'."\n";
		$data_info .= '</tr>'."\n";
		$data_info .= '</tbody>'."\n";
		$data_info .= '</table>';
	}

	exit_upload(true, $data_info);
}

if ($task == 'delete') {
	$data = explode(',', $input->getString('data', ''));
	if (substr($data[0], 1) == md5($data[1])) {
		if (JFile::delete($audio_dir.$data[2].'/'.$data[1])) echo "true";
		else echo "erreur";
	} else echo "chkdsk false !";
	JFactory::getApplication()->close();
}

function exit_upload($status,$datas='') {
	$response = array('response'=>$status,'datas'=>$datas);            
	echo json_encode($response);
	JFactory::getApplication()->close();
}
