<?php
    /*
    * Module APlayerFP pour Joomla! 3.x
    * Version J3.1F
    * Creation date: Octobre 2015
    * Author: Fabrice4821 - www.gmapfp.org
    * Author email: webmaster@gmapfp.org
	* License GNU/GPL
    */

defined('JPATH_PLATFORM') or die;
jimport( 'joomla.filesystem.folder' ); 
jimport( 'joomla.filesystem.file' ); 

class JFormFieldAudioFiles extends JFormField
{
	protected $type = 'AudioFiles';


	protected function getInput()
	{
		echo "<div class='alert alert-info'><h3>".JText::_('MOD_APLAYERFP_FREE_VERSION')."</h3></div>";
		
		$doc = JFactory::getDocument();
		$path = '../modules/mod_aplayerfp/';
		$compurl = JURI::base(). $path;
		
		//Ajout JQuery si non exist
		JHtml::_('jquery.framework');	

		// Dfinition de JUri::base() sans tenir compte du paramtre $config->get('live_site') de la config principale
		$uri = JUri::getInstance();
		$base['prefix'] = $uri->toString(array('scheme', 'host', 'port'));
		if (strpos(php_sapi_name(), 'cgi') !== false && !ini_get('cgi.fix_pathinfo') && !empty($_SERVER['REQUEST_URI']))
			$script_name = $_SERVER['PHP_SELF'];
		else $script_name = $_SERVER['SCRIPT_NAME'];
		$base['path'] = rtrim(dirname($script_name), '/\\');
		$Base_URL = $base['prefix'] . $base['path'] . '/';
		$module_id = $this->form->getValue('id');
		$audio_dir = JPATH_ROOT.'/modules/mod_aplayerfp/audio/'.$module_id;


		$doc = JFactory::getDocument();
		$doc->addStyleSheet( $Base_URL.'../modules/mod_aplayerfp/fields/audiofiles.css'); 
	    $doc->addScript( $Base_URL.'../modules/mod_aplayerfp/js/jquery.filedrop.js');
	    $doc->addScript( $Base_URL.'../modules/mod_aplayerfp/js/bootbox.min.js');
	    $doc->addScript( $Base_URL.'../modules/mod_aplayerfp/js/jquery.md5.js');
		
			
		$js = "
		jQuery(document).ready(function (){
			jQuery('#dropzonefp').unbind();
			jQuery('#dropzonefp').filedrop({
				fallback_id: 'upload_audiofp_input',   // an identifier of a standard file input element, becomes the target of \"click\" events on the dropzone
				url: '".$Base_URL."../index.php?option=com_ajaxdropfilesfp&task=add',              // upload handler, handles each file separately, can also be a function taking the file and returning a url
				paramname: 'fpfile',          // POST parameter name used on serverside to reference file, can also be a function taking the filename and returning the paramname
				allowedfiletypes: ['audio/wave','audio/wav','audio/x-wav','audio/x-pn-wav','audio/ogg','audio/mpeg','audio/x-mpeg','audio/mp3','audio/x-mp3','audio/mpeg3','audio/x-mpeg3','audio/mpg','audio/x-mpg','audio/x-mpegaudio'],   // filetypes allowed by Content-Type.  Empty array means no restrictions
				allowedfileextensions: ['.wav','.ogg','.mp3'], // file extensions allowed. Empty array means no restrictions
				maxfiles: 25,
				maxfilesize: 20,    // max file size in MBs
				queuefiles: 2,
				data: {
					module_id : function(){
						return jQuery('input[name=id_module]').val(); 
					}
				},
				error: function(err, file) {
					switch(err) {
						case 'BrowserNotSupported':
							bootbox.alert('".str_replace("'", "\'", JText::_('MOD_APLAYERFP_BROWSER_NOT_SUPPORT_HTML5'))."');
							break;
						case 'TooManyFiles':
							// user uploaded more than 'maxfiles'
							bootbox.alert('".str_replace("'", "\'", JText::_('MOD_APLAYERFP_TOO_MANY_FILES'))." !');
							break;
						case 'FileTooLarge':
							// program encountered a file whose size is greater than 'maxfilesize'
							// FileTooLarge also has access to the file which was too large
							// use file.name to reference the filename of the culprit file
							bootbox.alert(file.name+' ".str_replace("'", "\'", JText::_('MOD_APLAYERFP_FILE_TOO_LARGE'))." !');
							break;
						case 'FileTypeNotAllowed':
							// The file type is not in the specified list 'allowedfiletypes'
							bootbox.alert(file.name+' ".str_replace("'", "\'", JText::_('MOD_APLAYERFP_FILE_TYPE_NOT_ALLOWED'))." !');
							break;
						case 'FileExtensionNotAllowed':
							// The file extension is not in the specified list 'allowedfileextensions'
							bootbox.alert(file.name+' ".str_replace("'", "\'", JText::_('MOD_APLAYERFP_EXTENSION_TYPE_NOT_ALLOWED'))." !');
							break;
						default:
							break;
					}
				},
				dragOver: function() {
					jQuery(this).css('border', '3px dashed red');
					// user dragging files over #dropzone
				},
				dragLeave: function() {
					jQuery(this).css('border', '3px dashed #BBBBBB');
					// user dragging files out of #dropzone
				},
				drop: function() {
					// user drops file
					jQuery(this).css('border', '3px dashed #BBBBBB');
				},
				uploadStarted: function(i, file, len){
					// a file began uploading
					// i = index => 0, 1, 2, 3, 4 etc
					// file is the actual file of the index
					// len = total files user dropped
					var id_insert = jQuery.md5(file.name);
					var preview = jQuery('<div class=\"audio_box\" id=\"'+id_insert+'\" onclick=\"audio_infofp(this);\">'+
											'<span class=\"uploaded\">'+file.name+'</span>'+
											'<div class=\"progress progress-striped active\">'+
												'<div class=\"bar\"></div>'+
											'</div>'+
										'</div>');

					var reader = new FileReader();

					reader.onloadend = function(e){
							// e.target.result holds the DataURL which
							// can be used as a source of the audio:
					};

					// Reading the file as a DataURL. When finished,
					// this will trigger the onload function above:
					reader.readAsDataURL(file);

					preview.appendTo('#dropzonefp');
					// Associating a preview container
					// with the file, using jQuery's $.data():

					jQuery.data(file,preview);
				},
				uploadFinished: function(i, file, response, time) {
					// response is the data you got back from server in JSON format.
					// alert('uploadFinished');
					// console.log(response.response);
					// console.log(response.datas);
					var id_insert = jQuery.md5(file.name);
					var id_audio = 	'#'+id_insert;			
					if (response.response != true) {
						bootbox.alert(response.response);
						jQuery(id_audio).remove();
					} else {
						var preview = jQuery('<audio controls>'+
							'<source type=\"'+file.type+'\" src=\"'+'../modules/mod_aplayerfp/audio/'+jQuery('input[name=id_module]').val()+'/'+file.name+'\">'+
							'Your browser does not support the audio element.'+
							'</audio>');
						preview.appendTo(id_audio);
						
						var info = jQuery('<div class=\"info\" style=\"display:none;\">' + response.datas + '</div>');
						info.appendTo(id_audio);
						jQuery(id_audio).addClass('audio_info');
					}
				},
				progressUpdated: function(i, file, progress) {
					// this function is used for large files and updates intermittently
					// progress is the integer value of file being uploaded percentage to completion
					jQuery.data(file).find('.progress .bar').width(progress+'%');
				},
				beforeEach: function(file) {
					// file is a file object
					// return false to cancel upload
					var id_insert = jQuery.md5(file.name);
					var id_audio = 	'#'+id_insert;			
					if(!file.type.match(/^audio\//)){
						bootbox.alert('".str_replace("'", "\'", JText::_('MOD_APLAYERFP_ONLY_AUDIO_ALLOWED'))." !');
						return false;
					}
					if (jQuery(id_audio).val()=='') {
						bootbox.alert('".str_replace("'", "\'", JText::_('MOD_APLAYERFP_ALREADY_EXIST'))." !');
						return false;
					}
				},
				afterAll: function() {
					// runs after all files have been uploaded or otherwise dealt with
					jQuery('#dropzonefp .progress').delay(300).fadeIn(300).hide(300, function(){
					  jQuery(this).remove();
					});
				}
			});
			jQuery('#upload_audiofp_button').on('click',function(){
				jQuery('#upload_audiofp_input').trigger('click');
				return false;
			});
		});
		
		function audio_infofp(e) {
			var info = jQuery(\".info\", e);
			// bootbox.alert(info.html());
			bootbox.dialog({
			  message: info.html(),
			  title: \"".JText::_('MOD_APLAYERFP_AUDIO_DESCRIPTION')."\",
			  buttons: {
				delete: {
				  label: \"".JText::_('MOD_APLAYERFP_DELETE')."\",
				  className: \"btn-danger\",
				  callback: function() {
					var audio_id = '#' + jQuery(e).attr('id');
					var file_name = jQuery(\"span\", e).html();
					delete_file(file_name, audio_id);
				  }
				},
				main: {
				  label: \"".JText::_('MOD_APLAYERFP_CLOSE')."\",
				  className: \"btn-primary\",
				}
			  }
			});
		}
		
		function delete_file(file_name, audio_id) {
			jQuery.ajax({
				url: '".$Base_URL."../index.php?option=com_ajaxdropfilesfp&task=delete',
				data: {data: audio_id + ',' + file_name + ',' + jQuery('input[name=id_module]').val()}
			}).done(function(data) {
				if (data == 'true') {
					jQuery(audio_id).remove();
					nbre_file--;
				} else {bootbox.alert(data)};
			});
			return false;
		}
	";

		$doc->addScriptDeclaration($js);

?>
		<div id="dropzonefp" class="dropzonefp" >
			<div class="drop_info"><?php echo JText::_('MOD_APLAYERFP_DROP_FILE');?>
				<input type="file" id="upload_audiofp_input" multiple="">
				<a href="" id="upload_audiofp_button" class="btn btn-large btn-primary"><?php echo JText::_('MOD_APLAYERFP_DROP_FILE_BP');?></a>
			</div>
<?php

		if ($this->form instanceof JForm)
		{
			$params = $this->form->getValue('params');
			if (!$module_id) {
				echo '<div class="alert">'.JText::_('MOD_APLAYERFP_SAVE_BEFORE').'</div>';
				return;
			}

			$doc = JFactory::getDocument();
			require_once(JPATH_ROOT.'/modules/mod_aplayerfp/fields/getid3/getid3.php');
			    $this->getID3 = new getID3; 
				$this->getID3->option_md5_data        = true; 
				$this->getID3->option_md5_data_source = true; 
				$this->getID3->encoding               = 'UTF-8'; 
			$nbr_file = 0;

			if ($handle = @opendir($audio_dir)) {
				while (false !== ($file = readdir($handle))) {
					// strips files extensions      
					$crap   = array("mp3", "wav", "ogg");    
				   // hides folders, writes out ul of images and thumbnails from two folders
				   $extension = strtolower(substr(strrchr($file,'.'),1));
					if (in_array($extension, $crap) && $file != "." && $file != ".." && $file != "index.html" ) {
						$nbr_file++;
						$this->info = $this->getID3->analyze($audio_dir.'/'.$file);
						// die(print_r($this->info));
							$this->result = array(); 
							$this->result['album']        		= (isset($this->info['id3v2']['comments']['album'])    ? $this->info['id3v2']['comments']['album'][0]  : ''); 
							$this->result['title']       		= (isset($this->info['id3v2']['comments']['title'])    ? $this->info['id3v2']['comments']['title'][0]  : ''); 
							$this->result['format_name']     	= (isset($this->info['fileformat']) ? $this->info['fileformat'] : '').'/'.(isset($this->info['audio']['dataformat']) ? $this->info['audio']['dataformat'] : '').(isset($this->info['video']['dataformat']) ? '/'.$this->info['video']['dataformat'] : ''); 
							// $this->result['encoder_version'] 	= (isset($this->info['audio']['encoder'])         ? $this->info['audio']['encoder']         : ''); 
							// $this->result['encoder_options'] 	= (isset($this->info['audio']['encoder_options']) ? $this->info['audio']['encoder_options'] : ''); 
							// $this->result['bitrate_mode']    = (isset($this->info['audio']['bitrate_mode'])    ? $this->info['audio']['bitrate_mode']    : ''); 
							$this->result['channels']        	= (isset($this->info['audio']['channelmode'])     ? $this->info['audio']['channelmode']     : ''); 
							$this->result['bitrate']     	= (isset($this->info['audio']['bitrate'])     		  ? $this->info['audio']['bitrate']         : ''); 
							// $this->result['bits_per_sample'] = (isset($this->info['audio']['bits_per_sample']) ? $this->info['audio']['bits_per_sample'] : ''); 
							$this->result['playing_time']    	= (isset($this->info['playtime_seconds'])         ? round($this->info['playtime_seconds'])  : ''); 
							// $this->result['avg_bit_rate']    = (isset($this->info['audio']['bitrate'])         ? $this->info['audio']['bitrate']         : ''); 
							// $this->result['tags']            = (isset($this->info['tags'])                     ? $this->info['tags']                     : ''); 
							$this->result['comment']        	= (isset($this->info['id3v2']['comments']['comment'])  ? $this->info['id3v2']['comments']['comment'][0]                 : ''); 
							// $this->result['warning']         = (isset($this->info['warning'])                  ? $this->info['warning']                  : ''); 
							// $this->result['md5']             = (isset($this->info['md5_data'])                 ? $this->info['md5_data']                 : ''); 

						$data_info = '<div class="audio_box audio_info" id="'.md5($file).'" onclick="audio_infofp(this);">';
							$data_info .= '<span class="uploaded">'.$file.'</span>';
							$data_info .= '<audio controls=""><source type="audio/mp3" src="'.$Base_URL.'../modules/mod_aplayerfp/audio/'.$module_id.'/'.$file.'">Your browser does not support the audio element.</audio>';
							$data_info .= '<div class="info" style="display:none;">';
								$data_info .= '<table class="table-info">'."\n";
								$data_info .= '<body>'."\n";
								$data_info .= '<tr>'."\n";
								$data_info .= '<td class="titre">'.JText::_('MOD_APLAYERFP_FILE_NAME').' : </td>'."\n";
								$data_info .= '<td class="info">'.$this->result['title'].'</td>'."\n";
								$data_info .= '</tr>'."\n";
								$data_info .= '<tr>'."\n";
								$data_info .= '<td class="titre">'.JText::_('MOD_APLAYERFP_ALBUM').' : </td>'."\n";
								$data_info .= '<td class="info">'.$this->result['album'].'</td>'."\n";
								$data_info .= '</tr>'."\n";
								$data_info .= '<tr>'."\n";
								$data_info .= '<td class="titre">'.JText::_('MOD_APLAYERFP_CHANNELS').' : </td>'."\n";
								$data_info .= '<td class="info">'.$this->result['channels'].'</td>'."\n";
								$data_info .= '</tr>'."\n";
								$data_info .= '<tr>'."\n";
								$data_info .= '<td class="titre">'.JText::_('MOD_APLAYERFP_FORMAT_NAME').' : </td>'."\n";
								$data_info .= '<td class="info">'.$this->result['format_name'].'</td>'."\n";
								$data_info .= '</tr>'."\n";
								$data_info .= '<tr>'."\n";
								$data_info .= '<td class="titre">'.JText::_('MOD_APLAYERFP_SAMPLE_RATE').' : </td>'."\n";
								$data_info .= '<td class="info">'.$this->result['bitrate'].'</td>'."\n";
								$data_info .= '</tr>'."\n";
								$data_info .= '<tr>'."\n";
								$data_info .= '<td class="titre">'.JText::_('MOD_APLAYERFP_PLAYING_TIME').' : </td>'."\n";
								$data_info .= '<td class="info">'.$this->result['playing_time'].'</td>'."\n";
								$data_info .= '</tr>'."\n";
								$data_info .= '<tr>'."\n";
								$data_info .= '<td class="titre">'.JText::_('MOD_APLAYERFP_COMMENT').' : </td>'."\n";
								$data_info .= '<td class="info">'.$this->result['comment'].'</td>'."\n";
								$data_info .= '</tr>'."\n";
								$data_info .= '</tbody>'."\n";
								$data_info .= '</table>';
							$data_info .= '</div>';
						$data_info .= '</div>';
						
						echo $data_info;
					}
				}
				closedir($handle);
			}
			$doc->addScriptDeclaration('var nbre_file = '.$nbr_file.';');
		}
?>
		</div>
		<input type="hidden" name="id_module" value="<?php echo $module_id?>"/>
<?php
		return;
	}
	public function getLabel() {
		 return '';
	}
}