    /*
    * Module APlayerFP pour Joomla! 3.x
    * Version J3.2F
    * Creation date: Octobre 2017
    * Author: Fabrice4821 - www.gmapfp.org
    * Author email: webmaster@gmapfp.org
	* License GNU/GPL
    */
	
//Evite les conflits avec Mootools.
jQuery.ui.slider.prototype.widgetEventPrefix = 'slider';

// initialization - first element in playlist
function apalyerfp_classic(module_id) {
	// inner variables
	aplayerfp_tracker[module_id] = jQuery('#aplayerfp_' + module_id + ' .tracker');
	aplayerfp_volume[module_id] = jQuery('#aplayerfp_' + module_id + ' .volume');

	initAudioPlayer(module_id, jQuery('#aplayerfp_list_' + module_id + ' li:first-child'));

	// set volume
	aplayerfp_song[module_id].volume = 0.8;

	// initialize the volume slider
	aplayerfp_volume[module_id].slider({
		range: 'min',
		min: 1,
		max: 100,
		value: 80,
		start: function(event,ui) {},
		slide: function(event, ui) {
			aplayerfp_song[module_id].volume = ui.value / 100;
		},
		stop: function(event,ui) {},
	});

	// empty tracker slider
	aplayerfp_tracker[module_id].slider({
		range: 'min',
		min: 0, max: 10,
		start: function(event,ui) {},
		slide: function(event, ui) {
			aplayerfp_song[module_id].currentTime = ui.value;
		},
		stop: function(event,ui) {}
	});

	function initAudioPlayer(module_id, elem) {
		var url = elem.attr('audiourl');
		var title = elem.attr('titre');
		if (!title) title = elem.attr('audiourl');
		var album = elem.attr('album');
		var duration = elem.attr('time');
		
		jQuery('#aplayerfp_' + module_id + ' .title').text(title);
		jQuery('#aplayerfp_' + module_id + ' .album').text(album);

		aplayerfp_song[module_id] = new Audio(aplayerfp_url + 'audio/' + module_id + '/' + url);

		// timeupdate event listener
		aplayerfp_song[module_id].addEventListener('timeupdate',function (){
			var curtime = parseInt(aplayerfp_song[module_id].currentTime, 10);
			aplayerfp_tracker[module_id].slider('value', curtime);
		});

		jQuery('#aplayerfp_list_' + module_id + ' li').removeClass('active');
		elem.addClass('active');
	}
	function playAudio(module_id) {
		aplayerfp_song[module_id].play();

		aplayerfp_tracker[module_id].slider("option", "max", aplayerfp_song[module_id].duration);

		jQuery('#aplayerfp_' + module_id + ' .play').addClass('hidden');
		jQuery('#aplayerfp_' + module_id + ' .pause').addClass('visible');
	}
	function stopAudio(module_id) {
		aplayerfp_song[module_id].pause();

		jQuery('#aplayerfp_' + module_id + ' .play').removeClass('hidden');
		jQuery('#aplayerfp_' + module_id + ' .pause').removeClass('visible');
	}

	// play click
	jQuery('#aplayerfp_' + module_id + ' .play').click(function (e) {
		e.preventDefault();

		playAudio(module_id);
	});

	// pause click
	jQuery('#aplayerfp_' + module_id + ' .pause').click(function (e) {
		e.preventDefault();

		stopAudio(module_id);
	});

	// forward click
	jQuery('#aplayerfp_' + module_id + ' .fwd').click(function (e) {
		e.preventDefault();

		stopAudio(module_id);

		var next = jQuery('#aplayerfp_list_' + module_id + ' li.active').next();
		if (next.length == 0) {
			next = jQuery('#aplayerfp_list_' + module_id + ' li:first-child');
		}
		initAudioPlayer(module_id, next);
	});

	// rewind click
	jQuery('#aplayerfp_' + module_id + ' .rew').click(function (e) {
		e.preventDefault();

		stopAudio(module_id);

		var prev = jQuery('#aplayerfp_list_' + module_id + ' li.active').prev();
		if (prev.length == 0) {
			prev = jQuery('#aplayerfp_list_' + module_id + ' li:last-child');
		}
		initAudioPlayer(module_id, prev);
	});

	// show playlist
	jQuery('#aplayerfp_' + module_id + ' .pl').click(function (e) {
		e.preventDefault();
		jQuery('#aplayerfp_list_' + module_id).fadeToggle(300);
	});

	// playlist elements - click
	jQuery('#aplayerfp_list_' + module_id + ' li').click(function () {
		stopAudio(module_id);
		initAudioPlayer(module_id, jQuery(this));
	});
};